<?php
/***********************************************************************************
 * The contents of this file are subject to the vtiger CRM Public License Version 1.0
 * ("License"); You may not use this file except in compliance with the License
 * The Original Code is:  vtiger CRM Open Source
 * The Initial Developer of the Original Code is vtiger.
 * Portions created by vtiger are Copyright (C) vtiger.
 * All Rights Reserved.
 ************************************************************************************/

include_once 'modules/Vtiger/CRMEntity.php';

class VerySimpleModule extends Vtiger_CRMEntity {
	var $table_name = 'vtiger_verysimplemodule';
	var $table_index= 'verysimplemoduleid';

	/**
	 * Mandatory table for supporting custom fields.
	 */
	var $customFieldTable = Array('vtiger_verysimplemodulecf', 'verysimplemoduleid');

	/**
	 * Mandatory for Saving, Include tables related to this module.
	 */
	var $tab_name = Array('vtiger_crmentity', 'vtiger_verysimplemodule', 'vtiger_verysimplemodulecf');

	/**
	 * Mandatory for Saving, Include tablename and tablekey columnname here.
	 */
	var $tab_name_index = Array(
		'vtiger_crmentity' => 'crmid',
		'vtiger_verysimplemodule' => 'verysimplemoduleid',
		'vtiger_verysimplemodulecf'=>'verysimplemoduleid');

	/**
	 * Mandatory for Listing (Related listview)
	 */
	var $list_fields = Array (
		'LBL_LABEL' => array('verysimplemodule', 'label'),
		'LBL_AMOUNT' => array('verysimplemodule', 'amount'),
		'LBL_ACCOUNT_ID' => array('verysimplemodule', 'account_id'),

	);
	var $list_fields_name = Array (
		'LBL_LABEL' => 'label',
		'LBL_AMOUNT' => 'amount',
		'LBL_ACCOUNT_ID' => 'account_id',

	);

	// Make the field link to detail view
	var $list_link_field = 'label';

	// For Popup listview and UI type support
	var $search_fields = Array(
		'LBL_LABEL' => array('verysimplemodule', 'label'),
		'LBL_AMOUNT' => array('verysimplemodule', 'amount'),
		'LBL_ACCOUNT_ID' => array('verysimplemodule', 'account_id'),

	);
	var $search_fields_name = Array (
		'LBL_LABEL' => 'label',
		'LBL_AMOUNT' => 'amount',
		'LBL_ACCOUNT_ID' => 'account_id',

	);

	// For Popup window record selection
	var $popup_fields = Array ('label');

	// For Alphabetical search
	var $def_basicsearch_col = 'label';

	// Column value to use on detail view record text display
	var $def_detailview_recname = 'label';

	// Used when enabling/disabling the mandatory fields for the module.
	// Refers to vtiger_field.fieldname values.
	var $mandatory_fields = Array('label','assigned_user_id');

	var $default_order_by = 'label';
	var $default_sort_order='ASC';

	function VerySimpleModule() {
		$this->log =LoggerManager::getLogger('VerySimpleModule');
		$this->db = PearDatabase::getInstance();
		$this->column_fields = getColumnFields('VerySimpleModule');
	}

	/**
	* Invoked when special actions are performed on the module.
	* @param String Module name
	* @param String Event Type
	*/
	function vtlib_handler($moduleName, $eventType) {
 		if($eventType == 'module.postinstall') {
 			//Enable ModTracker for the module
 			static::enableModTracker($moduleName);
			//Create Related Lists
			static::createRelatedLists();
		} else if($eventType == 'module.disabled') {
			// Handle actions before this module is being uninstalled.
		} else if($eventType == 'module.preuninstall') {
			// Handle actions when this module is about to be deleted.
		} else if($eventType == 'module.preupdate') {
			// Handle actions before this module is updated.
		} else if($eventType == 'module.postupdate') {
			//Create Related Lists
			static::createRelatedLists();
		}
 	}
	
	/**
	 * Enable ModTracker for the module
	 */
	public static function enableModTracker($moduleName)
	{
		include_once 'vtlib/Vtiger/Module.php';
		include_once 'modules/ModTracker/ModTracker.php';
			
		//Enable ModTracker for the module
		$moduleInstance = Vtiger_Module::getInstance($moduleName);
		ModTracker::enableTrackingForModule($moduleInstance->getId());
	}
	
	protected static function createRelatedLists()
	{
		include_once('vtlib/Vtiger/Module.php');	

		$moduleInstance = Vtiger_Module::getInstance('Accounts');
		$relatedModuleInstance = Vtiger_Module::getInstance('VerySimpleModule');
		$relationLabel = 'LBL_VERYSIMPLEMODULE_LIST';
		$moduleInstance->setRelatedList(
			$relatedModuleInstance, $relationLabel, array('ADD'), 'get_dependents_list'
		);

	}
}